;
; S-OS SWORD clone for PC-G850
;

.include "char.h"
.include "screen.h"
.include "key.h"

.area _DATA

DEBUG=0

IBUF_SIZE=27
IBUF_ATTR_OFFSET=0
IBUF_NAME_OFFSET=1
IBUF_PASS_OFFSET=12
IBUF_SIZE_OFFSET=13
IBUF_DTADR_OFFSET=15
IBUF_EXADR_OFFSET=17
IBUF_HEAD_OFFSET=19
IBUF_BODY_OFFSET=21
IBUF_REALSIZE_OFFSET=23
IBUF_REST_OFFSET=25

ATTR_NUL=0
ATTR_BIN=1
ATTR_BAS=2
ATTR_ASC=4

ERROR_DEVICE_IO_ERROR=1
ERROR_DEVICE_OFFLINE=2
ERROR_BAD_FILE_DESCRIPTION=3
ERROR_WRITE_PROTECTED=4
ERROR_BAD_RECORD=5
ERROR_BAD_FILE_MODE=6
ERROR_BAD_ALLOCATION_TABLE=7
ERROR_FILE_NOT_FOUND=8
ERROR_DEVICE_FULL=9
ERROR_FILE_ALREADY_EXISTS=10
ERROR_RESERVED_FEATURE=11
ERROR_FILE_NOT_OPEN=12
ERROR_SYNTAX_ERROR=13
ERROR_BAD_DATA=14

MON_ORIG="#"
MON_EX="*"

ramdisk=0x100

;
; T|[gȂfBXN
;
_drdsb::
_dwtsb::
_fcb::
_set::
_reset::
	ld A, #ERROR_DEVICE_IO_ERROR
	scf

;
; T|[gȂI/O|[go
;
_peek_at::
_peek::
_poke_at::
_poke::

;
; T|[gȂʁEJ[\
;
_widch::
_linch::
_gtprc::

;
; T|[gȂv^
;
_lpton::
_lptof::
_lprnt::
	ret

;
; I/O|[g
;
; 
; C:|[gԍ
;
; o
; A:f[^
; F:j
;
_inp::
.if DEBUG
	call _mprnt
	.ascii /INP\r\0/
.endif
	in A, (C)
	ret

;
; I/O|[go
;
; 
; A:f[^
; C:|[gԍ
;
; o
; F:j
;
_outp::
.if DEBUG
	call _mprnt
	.ascii /OUTP\r\0/
.endif
	out (C), A
	ret

;
; 4bit16i1ɕϊ
;
; 
; A:ϊ(4bit)
;
; o
; A:
; F:j
;
_asc::
.if DEBUG
	call _mprnt
	.ascii /ASC\r\0/
.endif
	and #0x0f
	add #"0"
	cp #"9" + 1
	ret C
	add #"A" - "0" - 0x0a
	or A
	ret

;
; 16i14bitɕϊ
;
; 
; A:
;
; o
; A:l(4bit)
; Cy:G[ NC:
;
_hex::
.if DEBUG
	call _mprnt
	.ascii /HEX\r\0/
.endif
	sub #"0"
	jr C, _hex_err
	cp #10
	jr C, _hex_last
	
	sub #"A" - "0" - 10
	cp #16
	jr C, _hex_last
	
	sub #0x20
	cp #16
	jr C, _hex_last

_hex_last:
	or A
_hex_err:
	ret

;
; 16i28bitɕϊ
;
; 
; DE:̐擪AhX
;
; o
; A:l(8bit)
; Cy:G[ NC:
;
_two_hex::
.if DEBUG
	call _mprnt
	.ascii /2HEX\r\0/
.endif
	push BC
	push HL
	ex DE, HL
	
	ld A, (HL)
	call _hex
	jr C, _two_hex_last
	rlca
	rlca
	rlca
	rlca
	ld B, A
	inc HL
	
	ld A, (HL)
	call _hex
	jr C, _two_hex_last
	or B
	inc HL

_two_hex_last:
	ex DE, HL
	pop HL
	pop BC
	ret

;
; 16i416bitɕϊ
;
; 
; DE:̐擪AhX
;
; o
; HL:l(16bit)
; Cy:G[ NC:
;
_hlhex::
.if DEBUG
	call _mprnt
	.ascii /HLHEX\r\0/
.endif
	call _two_hex
	ret C
	ld H, A
	call _two_hex
	ld L, A
	ret

;
; ҂ ()
;
; 
; Ȃ
;
; o
; Ȃ
;
_wait:
	push BC
	ld B, #0
_wait_loop:
	djnz _wait_loop
	pop BC
	ret

;
; Wrap}XN𓾂 ()
;
; 
; H:yW
;
; o
; A:}XN
; F:j
;
_wrap_mask:
	push DE
	ld DE, #_wrap_mask_table
_wrap_mask0:
	push HL
	
	ld L, H
	ld H, #0
	add HL, DE
	ld A, (HL)
	
	pop HL
	pop DE
	ret

;
; C}p}XN𓾂 ()
;
; 
; H:yW
;
; o
; A:}XN
; F:j
;
_wrap_insert_mask:
	push DE
	ld DE, #_wrap_insert_mask_table
	jr _wrap_mask0

_wrap:
	.db 0
_wrap_mask_table:
	.db 0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80
_wrap_insert_mask_table:
	.db 0xff, 0xfe, 0xfc, 0xf8, 0xf0, 0xe0, 0xc0, 0x80

;
; _s߂ ()
;
; 
; HL:J[\ʒu
;
; o
; HL:_s
;
_lhead:
	push AF
	
	inc H
_lhead_loop:
	dec H
	call _wrap_mask
	ld L, A
	srl L
	ld A, (#_wrap)
	and L
	jr NZ, _lhead_loop
	ld L, #0
	
	pop AF
	ret

;
; _s߂ ()
;
; 
; HL:J[\ʒu
;
; o
; HL:_s
; AF:j
;
_llast:
	push BC

	; _s߂
	call _lhead
	ld B, H
	ld C, L

	; _s߂
	dec H
_llast_loop:
	inc H
	call _wrap_mask
	ld L, A
	ld A, (#_wrap)
	and L
	jr NZ, _llast_loop
	ld A, (#width)
	dec A
	ld L, A

	; 󔒂ł荶Ɉړ
_llast_loop2:
	call _cp_hl_bc
	jr Z, _llast_last
	call _print_gs
	call _scrn
	cp #" "
	jr Z, _llast_loop2

_llast_last:
	pop BC
	ret

;
; 1\ ()
;
; 
; A:ASCIIR[h
;
; o
; F:j
;
_print::
	push AF
	push BC
	push DE
	push HL
	push IX
	push IY

	call _csr

	; R[h?
	cp #0x20
	jr C, _print_ctrl

	; \J[\Eɓ
	call _print_char
	ld A, (#width)
	dec A
	cp L
	call Z, _print_wrap
	call _print_fs

_print_last:
	call _loc
	pop IY
	pop IX
	pop HL
	pop DE
	pop BC
	pop AF
	or A
	ret

_print_char:
	; \
	ld D, H
	ld E, L
	push BC
	push HL
	push DE
	call vram_addr
	ld (HL), A
	pop DE
	call update_vcell
	pop HL
	pop BC
	ret

_print_ctrl:
	; R[h
	call _print_ctrl0
	jr _print_last
_print_ctrl0:
	ld IX, #_print_jump_table
	rlca
	ld D, #0
	ld E, A
	add IX, DE
	ld D, 1(IX)
	ld E, 0(IX)
	push DE
	ret

_print_bel:
	; ^G x炷
	ld BC, #0x7f18
_print_bel_loop:
	ld A, #0x80
	out (C), A
	call _wait
	xor A
	out (C), A
	call _wait
	djnz _print_bel_loop
	ret

_print_ff:
	; ^L NA
	call clear_screen
	call refresh_screen
	xor A
	ld (#_wrap), A

_print_vt:
	; ^K J[\z[ɖ߂
	ld HL, #0
	ret

_print_soh:
	; ^A J[\_sɖ߂
	jp _lhead

_print_lf:
	; ^J J[\sɖ߂
	ld L, #0
	ret

_print_syn:
	; ^V J[\_sɈړ
	jp _llast

_print_cr:
	; ^M s
	call _llast
	jr _print_return

_print_bs:
	; ^H obNXy[X
_print_gs:
	; ^] J[\ɓ
	dec L
	ret P

	ld A, (#width)
	dec A
	ld L, A
	dec H
	ret P

	ld HL, #0
	ret

_print_rs:
	; ^^ J[\ɓ
	dec H
	ret P
	inc H
	ret

_print_us:
	; ^_ J[\ɓ
	inc H
	ld A, (#maxlin)
	dec A
	cp H
	ret NC
	dec H
	ret

_print_fs:
	; ^\ J[\Eɓ
	inc L
	ld A, (#width)
	dec A
	cp L
	ret NC
_print_return:
	; s
	ld L, #0
	inc H
	ld A, (#maxlin)
	dec A
	cp H
	ret NC

_print_dc3:
	; ^S XN[
	push HL
	call scroll_up
	call refresh_screen
	ld HL, #_wrap
	srl (HL)
	pop HL
	dec H
	ret P
	ld H, #0
	ret

_print_dc4:
	; ^T XN[
	push HL
	call scroll_down
	call refresh_screen
	ld HL, #_wrap
	sla (HL)
	pop HL
	inc H
	ld A, (#maxlin)
	dec A
	dec A
	cp H
	ret P
	inc A
	ld H, A

_print_nul:
	; ^@ Nul

_print_stx:
	; ^B ǑɈړ

_print_etx:
	; ^C

_print_eot:
	; ^D J[\ʒu̕폜

_print_enq:
	; ^E J[\ȍ~̕폜

_print_ack:
	; ^F ̌Ɉړ

_print_ht:
	; ^I Tab

_print_so:
	; ^N

_print_si:
	; ^O

_print_dle:
	; ^P

_print_dc1:
	; ^Q

_print_dc2:
	; ^R }

_print_nac:
	; ^U J[\ȑO̕폜

_print_can:
	; ^X

_print_etb:
	; ^W

_print_em:
	; ^Y

_print_sub:
	; ^Z

_print_esc:
	; ^[
	ret

_print_wrap:
	; }[h?
	ld A, (#_ins_mode)
	or A
	jr Z, _print_wrap_skip
	
	; VWraps?
	call _wrap_mask
	push HL
	ld HL, #_wrap
	and (HL)
	pop HL
	jr NZ, _print_wrap_skip

	; Wrapʒu𓾂
	push BC
	push HL
	ld A, (#_wrap)
	ld B, A
	
	; XN[ʒu𓾂
	ld A, (#maxlin)
	dec A
	inc H
	cp H
	jr C, _print_wrap_no_insert
	ld L, A
	
	; WrapʒuXN[
	call _wrap_insert_mask
	and B
	rlca
	ld C, A
	call _wrap_insert_mask
	cpl
	and B
	or C
	ld (#_wrap), A
	
	; ʂXN[
	ld C, #1
	call scroll_down0
	call refresh_screen
_print_wrap_no_insert:
	pop HL
	pop BC

_print_wrap_skip:
	; Wrap
	call _wrap_mask
	push HL
	ld HL, #_wrap
	or (HL)
	ld (HL), A
	pop HL
	ret

_print_jump_table:
	; Rg[L[[` Wve[u
	.dw #_print_nul
	.dw #_print_soh
	.dw #_print_stx
	.dw #_print_etx
	.dw #_print_eot
	.dw #_print_enq
	.dw #_print_ack
	.dw #_print_bel
	.dw #_print_bs
	.dw #_print_ht
	.dw #_print_lf
	.dw #_print_vt
	.dw #_print_ff
	.dw #_print_cr
	.dw #_print_so
	.dw #_print_si
	.dw #_print_dle
	.dw #_print_dc1
	.dw #_print_dc2
	.dw #_print_dc3
	.dw #_print_dc4
	.dw #_print_nac
	.dw #_print_syn
	.dw #_print_etb
	.dw #_print_can
	.dw #_print_em
	.dw #_print_sub
	.dw #_print_esc
	.dw #_print_fs
	.dw #_print_gs
	.dw #_print_rs
	.dw #_print_us

;
; 16i4\
;
; 
; HL:\l
;
; o
; AF:j
;
_prthl::
.if DEBUG
	call _mprnt
	.ascii /PRTHL\r\0/
.endif
	ld A, H
	call _prthx
	ld A, L

;
; 16i2\
;
; 
; A:\l
;
; o
; AF:j
;
_prthx::
.if DEBUG
	call _mprnt
	.ascii /PRTHX\r\0/
.endif
	push DE
	ld DE, #_prthx_buffer
	call _asc2
	call _mprnt
_prthx_buffer:
	.ascii /  \0/
	pop DE
	ret
	
_asc4:
	ld A, H
	call _asc2
	ld A, L
_asc2:
	push AF
	rlca
	rlca
	rlca
	rlca
	call _asc
	ld (DE), A
	inc DE
	pop AF
	call _asc
	ld (DE), A
	inc DE
	ret

;
; _słȂΉs
;
; 
; Ȃ
;
; o
; Ȃ
;
_nl::
	push AF
	push HL

	call _csr
	inc L
	dec L
	jr NZ, _nl_cr
	
	ld A, H
	call _lhead
	cp H
	jr Z, _nl_last
_nl_cr:
	call _ltnl

_nl_last:
	pop HL
	pop AF
	ret

;
; s
;
; 
; Ȃ
;
; o
; Ȃ
;
_ltnl::
	push AF
	
	ld A, #CR
	jr _print1

;
; x炷
;
; 
; Ȃ
;
; o
; Ȃ
;
_bell::
	push AF
	
	ld A, #BEL
	jr _print1

;
; Xy[X1\
;
; 
; Ȃ
;
; o
; Ȃ
;
_prnts::
	push AF
	
	ld A, #" "
_print1:
	call _print
	
	pop AF
	ret

;
; wʒu܂ŃXy[X\
;
; 
; B:ʒu
;
; o
; AF:j
;
_tab::
.if DEBUG
	call _mprnt
	.ascii /TAB\r\0/
.endif
	call _csr
	ld A, B
	sub L
	ret C
_tab_loop:
	dec A
	ret M
	call _prnts
	jr _tab_loop

;
; \(I[0)
;
; 
; DE:̐擪AhX
;
; o
; F:j
;
_msx::
	push BC
	push DE
	
	ld B, #0
	jr _msg_msx

;
; \(I[CR)
;
; 
; DE:̐擪AhX
;
; o
; F:j
;
_msg::
	push BC
	push DE

	ld B, #CR
_msg_msx:
	call _msg0

	pop DE
	pop BC
	ret

_msg0:
	push AF
_msg0_loop:
	ld A, (DE)
	inc DE
	cp B
	jr Z, _msg0_last
	call _print
	jr _msg0_loop
_msg0_last:
	pop AF
	ret

;
; \
;
; 
; Ȃ
;
; o
; F:j
;
_mprnt::
	ex (SP), HL
	push DE
	ex DE, HL
	
	push BC
	ld B, #0
	call _msg0
	pop BC

	ex DE, HL
	pop DE
	ex (SP), HL
	ret

;
; G[\
;
; 
; A:G[̎
;
; o
; Ȃ
;
_error::
	push AF
	push DE
	push IX

	or A
	jr Z, _error_last

	ld IX, #_error_table
	dec A
	cp #14
	jr NC, #_error_print
	rlca
	ld D, #0
	ld E, A
	add IX, DE

_error_print:
	ld D, 1(IX)
	ld E, 0(IX)
	call _msx
	call _bell

_error_last:
	pop IX
	pop DE
	pop AF
	ret

_error_table:
	.dw _error1
	.dw _error2
	.dw _error3
	.dw _error4
	.dw _error5
	.dw _error6
	.dw _error7
	.dw _error8
	.dw _error9
	.dw _error10
	.dw _error11
	.dw _error12
	.dw _error13
	.dw _error14

_error13:
	.ascii /Syntax /
_error0:
_error1:
_error3:
_error5:
_error6:
_error7:
_error11:
	.ascii /Error\0/
_error2:
	.ascii /Device Offline\0/
_error4:
	.ascii /Write Protected\0/
_error9:
	.ascii /Device Full\0/
_error8:
	.ascii /File Not Found\0/
_error10:
	.ascii /File Already Exists\0/
_error12:
	.ascii /File Not Open\0/
_error14:
	.ascii /Bad Data\0/

;
; L[𓾂(͑҂Ȃ, GR[Ȃ)
;
; 
; Ȃ
;
; o
; A:ĂL[ASCIIR[h
; F:j
;
_getky::
	push BC
	push DE
	push HL

	; ĂL[̃R[h𓾂
	call update_key
	call getkey
	jr C, _getky_pressed
	xor A

_getky_pressed:
	; OFFL[?
	cp #0x01
	jp Z, _boot

	; CTRLĂ邩?
	ld DE, #keycode2ascii_ctrl
	ld HL, #keytable + 3
	bit 3, (HL)
	jr NZ, _getky_conv

	; SHIFTĂ邩?
	ld DE, #keycode2ascii_shift
	ld HL, #keytable + 11
	bit 0, (HL)
	jr NZ, _getky_conv

	; 2ndFĂ邩?
	ld HL, #keymode
	bit KEYMODE_2NDF_BIT, (HL)
	jr NZ, _getky_conv

	; CAPSĂ邩?
	ld DE, #keycode2ascii_caps
	bit KEYMODE_CAPS_BIT, (HL)
	jr NZ, _getky_conv
	
	; ModifierȂ
	ld DE, #keycode2ascii_normal

_getky_conv:
	; ASCIIR[h𓾂
	ld H, #0
	ld L, A
	add HL, DE
	ld A, (HL)
	or A
	jr Z, _getky_last

	; 2ndF
	ld HL, #keymode
	res KEYMODE_2NDF_BIT, (HL)
	ld BC, #0x0200
	push AF
	call putstat
	pop AF

_getky_last:
	pop HL
	pop DE
	pop BC
	ret

; L[R[hASCIIR[hϊ\
keycode2ascii_normal:
	.db #0		; ͂Ȃ
	.db #0		; OFF
	.db #"q"	; Q
	.db #"w"	; W
	.db #"e"	; E
	.db #"r"	; R
	.db #"t"	; T
	.db #"y"	; Y
	.db #"u"	; U
	.db #"a"	; A
	.db #"s"	; S
	.db #"d"	; D
	.db #"f"	; F
	.db #"g"	; G
	.db #"h"	; H
	.db #"j"	; J
	.db #"k"	; K
	.db #"z"	; Z
	.db #"x"	; X
	.db #"c"	; C
	.db #"v"	; V
	.db #"b"	; B
	.db #"n"	; N
	.db #"m"	; M
	.db #","	; ,
	.db #0		; BASIC
	.db #0		; TEXT
	.db #0		; CAPS
	.db #0		; Ji
	.db #HT		; TAB
	.db #" "	; SPC
	.db #US		; down
	.db #RS		; up
	.db #GS		; left
	.db #FS		; right
	.db #0		; ANS
	.db #"0"	; 0
	.db #"."	; .
	.db #"="	; =
	.db #"+"	; +
	.db #CR		; return
	.db #"l"	; L
	.db #";"	; ;
	.db #0		; CONST
	.db #"1"	; 1
	.db #"2"	; 2
	.db #"3"	; 3
	.db #"-"	; -
	.db #0		; M+
	.db #"i"	; I
	.db #"o"	; O
	.db #DC2	; INS
	.db #"4"	; 4
	.db #"5"	; 5
	.db #"6"	; 6
	.db #"*"	; *
	.db #0		; RECM
	.db #"p"	; P
	.db #BS		; BS
	.db #0		; 
	.db #"7"	; 7
	.db #"8"	; 8
	.db #"9"	; 9
	.db #"/"	; /
	.db #")"	; )
	.db #0		; nPr
	.db #0		; DEG
	.db #0		; 
	.db #0		; x^2
	.db #"^"	; ^
	.db #"("	; (
	.db #0		; 1/x
	.db #0		; MDF
	.db #0		; 2ndF
	.db #0		; sin
	.db #0		; cos
	.db #0		; ln
	.db #0		; log
	.db #0		; tan
	.db #0		; F<->E
	.db #FF		; CLS
	.db #ETX	; BREAK
	.db #0		; 
keycode2ascii_caps:
	.db #0		; ͂Ȃ
	.db #0		; CAPS + OFF
	.db #"Q"	; CAPS + Q
	.db #"W"	; CAPS + W
	.db #"E"	; CAPS + E
	.db #"R"	; CAPS + R
	.db #"T"	; CAPS + T
	.db #"Y"	; CAPS + Y
	.db #"U"	; CAPS + U
	.db #"A"	; CAPS + A
	.db #"S"	; CAPS + S
	.db #"D"	; CAPS + D
	.db #"F"	; CAPS + F
	.db #"G"	; CAPS + G
	.db #"H"	; CAPS + H
	.db #"J"	; CAPS + J
	.db #"K"	; CAPS + K
	.db #"Z"	; CAPS + Z
	.db #"X"	; CAPS + X
	.db #"C"	; CAPS + C
	.db #"V"	; CAPS + V
	.db #"B"	; CAPS + B
	.db #"N"	; CAPS + N
	.db #"M"	; CAPS + M
	.db #","	; CAPS + ,
	.db #0		; CAPS + BASIC
	.db #0		; CAPS + TEXT
	.db #0
	.db #0		; CAPS + Ji
	.db #HT		; CAPS + TAB
	.db #" "	; CAPS + SPC
	.db #US		; CAPS + down
	.db #RS		; CAPS + up
	.db #GS		; CAPS + left
	.db #FS		; CAPS + right
	.db #0		; CAPS + ANS
	.db #"0"	; CAPS + 0
	.db #"."	; CAPS + .
	.db #"="	; CAPS + =
	.db #"+"	; CAPS + +
	.db #CR		; CAPS + return
	.db #"L"	; CAPS + L
	.db #";"	; CAPS + ;
	.db #0		; CAPS + CONST
	.db #"1"	; CAPS + 1
	.db #"2"	; CAPS + 2
	.db #"3"	; CAPS + 3
	.db #"-"	; CAPS + -
	.db #0		; CAPS + M+
	.db #"I"	; CAPS + I
	.db #"O"	; CAPS + O
	.db #DC2	; CAPS + INS
	.db #"4"	; CAPS + 4
	.db #"5"	; CAPS + 5
	.db #"6"	; CAPS + 6
	.db #"*"	; CAPS + *
	.db #0		; CAPS + RECM
	.db #"P"	; CAPS + P
	.db #BS		; CAPS + BS
	.db #0		; CAPS + 
	.db #"7"	; CAPS + 7
	.db #"8"	; CAPS + 8
	.db #"9"	; CAPS + 9
	.db #"/"	; CAPS + /
	.db #")"	; CAPS + )
	.db #0		; CAPS + nPr
	.db #0		; CAPS + DEG
	.db #0		; CAPS + 
	.db #0		; CAPS + x^2
	.db #"^"	; CAPS + ^
	.db #"("	; CAPS + (
	.db #0		; CAPS + 1/x
	.db #0		; CAPS + MDF
	.db #0		; CAPS + 2ndF
	.db #0		; CAPS + sin
	.db #0		; CAPS + cos
	.db #0		; CAPS + ln
	.db #0		; CAPS + log
	.db #0		; CAPS + tan
	.db #0		; CAPS + F<->E
	.db #FF		; CAPS + CLS
	.db #ETX	; CAPS + BREAK
	.db #0		; 
keycode2ascii_shift:
	.db #0		; ͂Ȃ
	.db #0		; SHIFT + OFF
	.db #"!"	; SHIFT + Q
	.db #"\""	; SHIFT + W
	.db #"#"	; SHIFT + E
	.db #"$"	; SHIFT + R
	.db #"%"	; SHIFT + T
	.db #"&"	; SHIFT + Y
	.db #"'"	; SHIFT + U
	.db #"["	; SHIFT + A
	.db #"]"	; SHIFT + S
	.db #"{"	; SHIFT + D
	.db #"}"	; SHIFT + F
	.db #"\\"	; SHIFT + G
	.db #"|"	; SHIFT + H
	.db #"~"	; SHIFT + J
	.db #"_"	; SHIFT + K
	.db #0		; SHIFT + Z
	.db #0		; SHIFT + X
	.db #0		; SHIFT + C
	.db #0		; SHIFT + V
	.db #0		; SHIFT + B
	.db #0		; SHIFT + N
	.db #0		; SHIFT + M
	.db #"?"	; SHIFT + ,
	.db #0		; SHIFT + BASIC
	.db #0		; SHIFT + TEXT
	.db #0
	.db #0		; SHIFT + Ji
	.db #HT		; SHIFT + TAB
	.db #" "	; SHIFT + SPC
	.db #FS		; SHIFT + Down
	.db #0		; SHIFT + up
	.db #0		; SHIFT + left
	.db #0		; SHIFT + right
	.db #0		; SHIFT + ANS
	.db #"0"	; SHIFT + 0
	.db #"."	; SHIFT + .
	.db #"="	; SHIFT + =
	.db #"+"	; SHIFT + +
	.db #CR		; SHIFT + return
	.db #"="	; SHIFT + L
	.db #":"	; SHIFT + ;
	.db #0		; SHIFT + CONST
	.db #"1"	; SHIFT + 1
	.db #"2"	; SHIFT + 2
	.db #"3"	; SHIFT + 3
	.db #"-"	; SHIFT + -
	.db #0		; SHIFT + M+
	.db #"<"	; SHIFT + I
	.db #">"	; SHIFT + O
	.db #EOT	; SHIFT + INS
	.db #"4"	; SHIFT + 4
	.db #"5"	; SHIFT + 5
	.db #"6"	; SHIFT + 6
	.db #"*"	; SHIFT + *
	.db #0		; SHIFT + RECM
	.db #"@"	; SHIFT + P
	.db #BS		; SHIFT + BS
	.db #0		; SHIFT + 
	.db #"7"	; SHIFT + 7
	.db #"`"	; SHIFT + 8
	.db #"9"	; SHIFT + 9
	.db #"/"	; SHIFT + /
	.db #")"	; SHIFT + )
	.db #0		; SHIFT + nPr
	.db #0		; SHIFT + DEG
	.db #0		; SHIFT + 
	.db #0		; SHIFT + x^2
	.db #"^"	; SHIFT + ^
	.db #"("	; SHIFT + (
	.db #0		; SHIFT + 1/x
	.db #0		; SHIFT + MDF
	.db #0		; SHIFT + 2ndF
	.db #0		; SHIFT + sin
	.db #0		; SHIFT + cos
	.db #0		; SHIFT + ln
	.db #0		; SHIFT + log
	.db #0		; SHIFT + tan
	.db #0		; SHIFT + F<->E
	.db #FF		; SHIFT + CLS
	.db #ETX	; SHIFT + BREAK
	.db #0		; 
keycode2ascii_ctrl:
	.db #0		; ͂Ȃ
	.db #0		; CTRL + OFF
	.db #DC1	; CTRL + Q
	.db #ETB	; CTRL + W
	.db #ENQ	; CTRL + E
	.db #DC2	; CTRL + R
	.db #DC4	; CTRL + T
	.db #EM		; CTRL + Y
	.db #NAC	; CTRL + U
	.db #SOH	; CTRL + A
	.db #DC3	; CTRL + S
	.db #EOT	; CTRL + D
	.db #ACK	; CTRL + F
	.db #BEL	; CTRL + G
	.db #BS		; CTRL + H
	.db #LF		; CTRL + J
	.db #VT		; CTRL + K
	.db #SUB	; CTRL + Z
	.db #CAN	; CTRL + X
	.db #ETX	; CTRL + C
	.db #SYN	; CTRL + V
	.db #STX	; CTRL + B
	.db #SO		; CTRL + N
	.db #CR		; CTRL + M
	.db #","	; CTRL + ,
	.db #0		; CTRL + BASIC
	.db #0		; CTRL + TEXT
	.db #0		; CTRL + CAPS
	.db #0		; CTRL + Ji
	.db #HT		; CTRL + TAB
	.db #" "	; CTRL + SPC
	.db #US		; CTRL + down
	.db #RS		; CTRL + up
	.db #GS		; CTRL + left
	.db #FS		; CTRL + right
	.db #0		; CTRL + ANS
	.db #"0"	; CTRL + 0
	.db #"."	; CTRL + .
	.db #"="	; CTRL + =
	.db #"+"	; CTRL + +
	.db #CR		; CTRL + return
	.db #FS		; CTRL + L
	.db #";"	; CTRL + ;
	.db #0		; CTRL + CONST
	.db #"1"	; CTRL + 1
	.db #"2"	; CTRL + 2
	.db #"3"	; CTRL + 3
	.db #"-"	; CTRL + -
	.db #0		; CTRL + M+
	.db #EM		; CTRL + I
	.db #US		; CTRL + O
	.db #0		; CTRL + INS
	.db #"4"	; CTRL + 4
	.db #"5"	; CTRL + 5
	.db #"6"	; CTRL + 6
	.db #"*"	; CTRL + *
	.db #0		; CTRL + RECM
	.db #DLE	; CTRL + P
	.db #BS		; CTRL + BS
	.db #0		; CTRL + 
	.db #"7"	; CTRL + 7
	.db #"8"	; CTRL + 8
	.db #"9"	; CTRL + 9
	.db #"/"	; CTRL + /
	.db #GS		; CTRL + )
	.db #0		; CTRL + nPr
	.db #0		; CTRL + DEG
	.db #0		; CTRL + 
	.db #0		; CTRL + x^2
	.db #RS		; CTRL + ^
	.db #ESC	; CTRL + (
	.db #0		; CTRL + 1/x
	.db #0		; CTRL + MDF
	.db #0		; CTRL + 2ndF
	.db #0		; CTRL + sin
	.db #0		; CTRL + cos
	.db #0		; CTRL + ln
	.db #0		; CTRL + log
	.db #0		; CTRL + tan
	.db #0		; CTRL + F<->E
	.db #FF		; CTRL + CLS
	.db #ETX	; CTRL + BREAK
	.db #0		; 

;
; BreakL[Ă邩?
;
; 
; Ȃ
;
; o
; A:j
; Z:Ă NZ:ĂȂ
;
_brkey::
.if DEBUG
	;call _mprnt
	;.ascii /BRKEY\r\0/
.endif
	call _getky
	cp #ETX
	ret

;
; L[𓾂(͑҂, GR[Ȃ)
;
; 
; Ȃ
;
; o
; A:ĂL[ASCIIR[h
; F:j
;
_inkey::
.if DEBUG
	call _mprnt
	.ascii /INKEY\r\0/
.endif
	push HL
	jr _inkey_flget

;
; L[𓾂(͑҂, GR[Ȃ, J[\)
;
; 
; Ȃ
;
; o
; A:ĂL[ASCIIR[h
; F:j
;
_flget::
	push HL
	ld HL, #screenmode
	set SCREENMODE_VISIBLECURSOR_BIT, (HL)

_inkey_flget:
	push BC
	push DE
	push IX
	push IY
	
_inkey_flget_loop:
	; ĂL[ASCIIR[h𓾂
	call _wait
	call _wait
	call _wait
	call _wait
	ld DE, (#cursor_location)
	call update_vcell
	call _getky
	or A
	jr Z, _inkey_flget_loop

	; J[\
	push AF
	ld HL, #screenmode
	res SCREENMODE_VISIBLECURSOR_BIT, (HL)
	ld DE, (#cursor_location)
	call update_vcell
	pop AF

	pop IY
	pop IX
	pop DE
	pop BC
	pop HL
	ret

;
; HLBCr ()
;
; 
; BC:
; HL:
;
; o
; Cy:L[, NC:Ȃ
; Z:, NZ:قȂ
; A:j
;
_cp_hl_bc:
	ld A, B
	cp H
	ret NZ
	ld A, C
	cp L
	ret

;
; ̓͂𓾂 ()
;
; 
; DE:obt@̃AhX
;
; o
; AF:j
;
_getl::
	push HL
	push BC
	push DE

_getl_loop:
	; L[͂𓾂
	call _csr
	call _flget
	cp #CR
	jr Z, _getl_cr
	cp #ESC
	jr Z, _getl_esc
	cp #ETX
	jr Z, _getl_esc
	cp #EOT
	jr Z, _getl_del
	cp #BS
	jr Z, _getl_bs
	cp #DC2
	jr Z, _getl_ins
	cp #" "
	jr C, _getl_ctrl
_getl_char:
	push HL
	ld HL, #_ins_mode
	bit 0, (HL)
	pop HL
	jr Z, _getl_ctrl
	push DE
	push AF
	call _getl_setbuf
	pop AF
	call _print
	call _msx
	ld A, #FS
	call _print
	inc BC
_getl_char_loop:
	ld A, #GS
	call _print
	dec BC
	ld A, B
	or C
	jr NZ, _getl_char_loop
	pop DE
	jr _getl_loop
_getl_ctrl:
	call _print
	jr _getl_loop

_getl_cr:
	; ͏I
	call _lhead
	call _getl_setbuf
	call _ltnl
_getl_last:
	xor A
	ld (#_ins_mode), A
	pop DE
	pop BC
	pop HL
	ret

_getl_esc:
	; ̓LZ
	ld A, #ESC
	ld (DE), A
	inc DE
	xor A
	ld (DE), A
	jr _getl_last

_getl_ins:
	; Ins
	ld A, (#_ins_mode)
	xor #1
	ld (#_ins_mode), A
	jr _getl_loop

_getl_bs:
	; obNXy[X
	call _print_gs
	call _loc
_getl_del:
	; 폜
	call _getl_setbuf
	push DE
	push HL
	inc DE
	call _msx
	call _prnts
	pop HL
	pop DE
	call _loc
	jp _getl_loop

_getl_setbuf:
	push HL
	push DE

	; _s𓾂
	push HL
	call _llast
	ld B, H
	ld C, L
	pop HL

	; ݈ʒu_sɂ邩?
	call _cp_hl_bc
	jr C, _getl_setbuf_skip

	; ݈ʒu_s܂Ńobt@ɏ
_getl_setbuf_loop:
	call _scrn
	ld (DE), A
	inc DE
	call _cp_hl_bc
	jr Z, _getl_setbuf_skip
	call _print_fs
	jr _getl_setbuf_loop

	; 0
_getl_setbuf_skip:
	ld H, D
	ld L, E
	xor A
	ld (DE), A
	inc DE
	ld (DE), A

	pop DE
	or A
	sbc HL, DE
	ld B, H
	ld C, L
	pop HL
	ret

_ins_mode:
	.db 0

;
; |[Y
;
; 
; Ȃ
;
; o
; AF:j
;
_pause::
.if DEBUG
	call _mprnt
	.ascii /PAUSE\r\0/
.endif
	call _getky
	
	; ^C?
	cp #ETX
	jr Z, _pause_jp
	
	; Xy[X?
	cp #" "
	jr NZ, _pause_next

	; |[Y
_pause_loop:
	call _getky
	cp #" "
	jr NZ, _pause_loop

_pause_next:
	; ̃AhX
	ex (SP), HL
	inc HL
	inc HL
	ex (SP), HL
	ret

_pause_jp:
	; Wv
	ex (SP), HL
	push DE
	ld A, (HL)
	ld E, A
	inc HL
	ld A, (HL)
	ld D, A
	ex DE, HL
	pop DE
	ex (SP), HL
	ret

;
; J[\ʒu𓾂
;
; 
; Ȃ
; o
; HL:J[\ʒu
;
_csr::
	ld HL, (#cursor_location)
	or A
.if DEBUG
	call _mprnt
	.ascii /CSR\r\0/
.endif
	ret

;
; J[\ڂ
;
; 
; HL:J[\ʒu
;
; o
; Ȃ
;
_loc::
	ld (#cursor_location), HL
	or A
.if DEBUG
	call _mprnt
	.ascii /LOC\r\0/
.endif
	ret

;
; 𓾂
;
; 
; HL:ʒu
;
; o
; A:
; F:j
;
_scrn::
.if DEBUG
	call _mprnt
	.ascii /SCRN\r\0/
.endif
	push BC
	push DE
	push HL
	push IX
	
	ex DE, HL
	call vram_addr
	ld A, (HL)
	
	pop IX
	pop HL
	pop DE
	pop BC
	ret

;
; t@C𐳋K ()
;
; 
; DE:̓t@C̐擪
; HL:t@Cޗ̈̐擪
;
; o
; Cy:sȃt@C NC:
; A:j
; DE:̓t@C̎̃AhX
;
_reg_file:
	push BC
	push HL

	; foCX
	ld A, (DE)
	ld (#_reg_file_dev), A
	inc DE
	ld A, (DE)
	inc DE
	cp #":"
	jr Z, _reg_file_skip

	ld A, (#dvsw)
	ld (#_reg_file_dev), A
	dec DE
	dec DE

_reg_file_skip:
	; t@C`FbN
	ld A, (DE)
	cp #" "
	jr Z, _reg_file_ng
	jr C, _reg_file_ng
	cp #":"
	jr Z, _reg_file_ng
	cp #"."
	jr Z, _reg_file_ng

	; t@C(vC})
	ld B, #8
	call _strcpy
	jr C, _reg_file_ng

	; t@C(gq)
	ld B, #3
	ld A, (DE)
	cp #"."
	jr NZ, _reg_file_noperiod
_reg_file_period:
	inc DE
_reg_file_noperiod:
	call _strcpy
	jr C, _reg_file_ng
	jr _reg_file_ok

_reg_file_ok:
	xor A
_reg_file_last:
	pop HL
	pop BC
	ret
_reg_file_ng:
	ld A, #ERROR_BAD_FILE_DESCRIPTION
	scf
	jr _reg_file_last

_strcpy:
_strcpy_loop:
	; Rs[
	ld A, (DE)
	cp #" "
	jr C, _strcpy_pad
	cp #":"
	jr Z, _strcpy_pad
	cp #"."
	jr Z, _strcpy_pad
	inc DE
	ld (HL), A
	inc HL
	
	; 񒷂`FbN
	dec B
	jr Z, _strcpy_last
	jr _strcpy_loop

_strcpy_pad:
_strcpy_pad_loop:
	; 󔒂ł߂
	ld (HL), #" "
	inc HL
	dec B
	jr NZ, _strcpy_pad_loop

_strcpy_last:
_strcpy_ok:
	xor A
	ret
_strcpy_ng:
	scf
	ret

_reg_file_dev:
	.db 0

;
; t@C̐擪𓾂 ()
;
; 
; Ȃ
;
; o
; A:G[R[h
; Cy:G[ NC:G[Ȃ
; IX:t@C̐擪AhX
; IY:t@C̍ŏIAhX
;
_get_filetop:
	call _check_dsk
	ret C

	ld A, (#dsk)

	ld IY, #0x7600
	ld IX, (#memax)
	push BC
	ld BC, #25 + 1
	add IX, BC
	pop BC
	cp #"B"
	jr Z, _get_filetop_ok

	ld IY, #sos - 1
	ld IX, #ramdisk
	cp #"A"
	jr Z, _get_filetop_ok
_get_filetop_ng:
	ld A, #ERROR_DEVICE_OFFLINE
	scf
	ret
_get_filetop_ok:
	xor A
	ret

;
; t@C̏𓾂 ()
;
; 
; B:Ԗڂ̃t@C̏𓾂邩?
; DE:t@C̏ݐ̐擪
;
; o
; A:G[R[h
; C:t@CȂ NC:t@C
;
_get_fileinfo:
	push BC
	push HL
	push IX
	push IY
	call _get_fileinfo_main
	pop IY
	pop IX
	pop HL
	pop BC
	ret

_get_fileinfo_main:
	; t@C̐擪𓾂
	call _get_filetop
	ret C

	inc B
_get_fileinfo_loop:
	push BC
	push DE
	push IY
	push DE

	; Et@CEpX[h
	push IX
	pop HL
	ld BC, #13
	ldir

	; 擪AhXEsJnAhX
	inc HL
	inc HL
	inc HL
	inc HL
	ld C, #6
	ldir

	; t@C̃AhX(wb_)
	push IX
	pop HL
	call _st

	; t@C̃AhX(f[^)
	ld C, #35
	add HL, BC
	call _st

	; t@CTCY(wb_)͌ŏ
	inc DE
	inc DE

	; cTCY
	or A
	push IY
	pop HL
	push IX
	pop BC
	sbc HL, BC
	call _st

	; t@CTCY(wb_)
	pop IY
	call _get_file_size
	ld IBUF_REALSIZE_OFFSET+1(IY), D
	ld IBUF_REALSIZE_OFFSET+0(IY), E

	; t@CTCY
	ld HL, #-34
	add HL, DE
	ex DE, HL
	ld IBUF_SIZE_OFFSET+1(IY), D
	ld IBUF_SIZE_OFFSET+0(IY), E

	pop IY
	pop DE
	pop BC

	; t@C邩?
	ld A, (IX)
	inc A
	jr Z, _get_file_ng

	; ̃t@C̃AhX𓾂
	push DE
	call _get_file_size
	add IX, DE
	ld A, D
	or E
	pop DE
	jr Z, _get_file_ng

	dec B
	jr NZ, _get_fileinfo_loop

	xor A
	ret

_get_file_ng:
	ld A, #ERROR_FILE_NOT_FOUND
	scf
	ret

_get_file_size:
	ld D, 18(IX)
	ld E, 17(IX)
	ret

_st:
	; (DE) := HL, DE += 2
	ld A, L
	ld (DE), A
	inc DE
	ld A, H
	ld (DE), A
	inc DE
	ret

;
; foCX`FbN ()
;
; 
; Ȃ
;
; o
; A:G[R[h
; Cy:G[ NC:Ȃ
;
_check_dsk:
	ld A, (#dsk)
	cp #"A"
	jr Z, _check_ibuf_ok
	cp #"B"
	jr Z, _check_ibuf_ok
_check_dsk_ng:
	ld A, #ERROR_DEVICE_OFFLINE
	scf
	ret
_check_dsk_ok:
	xor A
	ret

;
; foCXɏ߂邩`FbN ()
;
; 
; Ȃ
;
; o
; A:G[R[h
; Cy:G[ NC:
;
_check_protect:
	; Bɂ͏߂Ȃ
	ld A, (#dsk)
	cp #"B"
	ld A, #ERROR_WRITE_PROTECTED
	scf
	ret Z

	xor A
	ret

;
; FCB폜 ()
;
; 
; Ȃ
;
; o
; AF,BC,DE,HL:j
;
_del_ibuf:
	ld A, (#dvsw)
	ld (#dsk), A
	ld DE, (#ibfad)
	ld H, D
	ld L, E
	inc HL
	ld BC, #IBUF_SIZE
	ld (HL), #0
	ldir
	xor A
	ret

;
; FCB܂Ă邩`FbN ()
;
; 
; Ȃ
;
; o
; A:G[R[h
; Cy:FCBȂ NC:
;
_check_ibuf:
	; foCX`FbN
	call _check_dsk
	ret C
	; `FbN
	xor A
	ld HL, (#ibfad)
	cp (HL)
	jr NZ, _check_ibuf_ok
_check_ibuf_ng:
	ld A, #ERROR_FILE_NOT_OPEN
	scf
	ret
_check_ibuf_ok:
	xor A
	ret

;
; t@C ()
;
; 
; Ȃ
;
; o
; A:G[R[h
; Cy:G[ NC:G[Ȃ
; B:t@Cԍ
; C:j
;
_find_file:
	push DE
	push HL

	; , t@C, pX[hۑ
	ld DE, #_find_file_buffer
	ld HL, (#ibfad)
	ld BC, #13
	push BC
	push DE
	push HL
	ldir

	; 
	ld B, #-1
	ld DE, #_buffer
_find_file_loop:
	inc B
	call _get_fileinfo
	jr C, _find_file_last
	inc DE
	call _fsame
	dec DE
	jr NZ, _find_file_loop

_find_file_last:
	; XV
	ld A, B
	ld DE, (#ibfad)
	push AF
	call _get_fileinfo
	pop AF

	; t@C߂
	pop DE
	pop HL
	pop BC
	ldir

	pop HL
	pop DE
	ld B, A
	jr C, _find_file_ng
_find_file_ok:
	xor A
	ret
_find_file_ng:
	ld A, #ERROR_FILE_NOT_FOUND
	scf
	ret

_find_file_buffer:
	.db 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

;
; cfBXNXy[X𓾂 ()
;
; 
; Ȃ
;
; o
; HL:fBXNXy[X
; AF:j
;
_get_diskspace:
	push BC
	push DE
	push IX

	ld DE, #_buffer
	ld IX, #_buffer
	ld B, #255
	call _get_fileinfo

	ld H, IBUF_REST_OFFSET+1(IX)
	ld L, IBUF_REST_OFFSET+0(IX)

	pop IX
	pop DE
	pop BC
	ret

;
; JgfoCX𓾂
;
; 
; Ȃ
;
; o
; A:foCX
;
_rdvsw::
	ld A, (#dvsw)
	ret

;
; JgfoCXύX
;
; 
; A:foCX
;
; o
; Ȃ
;
_sdvsw::
	ld (#dvsw), A
	ret

;
; fBNg\
;
; 
; Ȃ
;
; o
; A:G[R[h
; Cy:G[ NC:
;
_dir::
	push BC
	push DE
	push HL
	push IX

	call _check_dsk
	jr C, _dir_last

_dir_main:
	ld B, #0
_dir_loop:
	; t@C𓾂
	ld DE, #_buffer
	call _get_fileinfo
	ccf
	jr NC, _dir_last
	inc B

	; \
	ld HL, #_buffer
	ld IX, #_buffer
	ld A, (HL)
	inc HL
	or A
	ld DE, #_print_attr_nul
	jr Z, _print_attr
	dec A
	ld DE, #_print_attr_bin
	jr Z, _print_attr
	dec A
	ld DE, #_print_attr_bas
	jr Z, _print_attr
	dec A
	dec A
	ld DE, #_print_attr_asc
	jr Z, _print_attr
	ld DE, #_print_attr_unknown
_print_attr:
	call _msx
	call _prnts
	call _prnts

	; foCX\
	ld A, (#dsk)
	call _print
	ld A, #":"
	call _print

	; t@C\
	call _print_filename
	
	;  JnAhX\
	ld D, IBUF_SIZE_OFFSET+1(IX)
	ld E, IBUF_SIZE_OFFSET+0(IX)
	ld H, IBUF_DTADR_OFFSET+1(IX)
	ld L, IBUF_DTADR_OFFSET+0(IX)
	call _print_addr

	; IAhX\
	add HL, DE
	dec HL
	call _print_addr
	
	; sAhX\
	ld H, IBUF_EXADR_OFFSET+1(IX)
	ld L, IBUF_EXADR_OFFSET+0(IX)
	call _print_addr
	call _ltnl
	jr _dir_loop

_dir_last:
	pop IX
	pop HL
	pop DE
	pop BC
	ret

_printn:
	; n\
	inc C
_printn_loop:
	dec C
	ret Z
	ld A, (HL)
	inc HL
	call _print
	jr _printn_loop

_print_addr:
	; AhX\
	ld A, #":"
	call _print
	jp _prthl

_print_filename:
	; t@C\
	ld C, #8
	call _printn
	ld A, #"."
	call _print
	ld C, #3
	jr _printn

_print_attr_nul:
	.ascii /Nul\0/
_print_attr_bin:
	.ascii /Bin\0/
_print_attr_bas:
	.ascii /Bas\0/
_print_attr_asc:
	.ascii /Asc\0/
_print_attr_unknown:
	.ascii /???\0/

;
; t@Cp[^ݒ肷
;
; 
; A:
; DE:t@C̐擪AhX
;
; o
; A:G[R[h
; Cy:G[ NC:
; BC,DE,HL:j
;
_file::
	; t@C
	ld HL, (#ibfad)
	ld (HL), A
	inc HL

	; t@C
	call _reg_file
	push AF

	; foCX
	ld A, (#_reg_file_dev)
	ld (#dsk), A

	; pX[h
	ld BC, #11
	add HL, BC
	ld A, #" "
	ld (HL), A

	pop AF
	ret

_file_ng:
	push AF
	call _del_ibuf
	pop AF
	ret

;
; FCBobt@̃t@C\
;
; 
; Ȃ
;
; o
; AF,BC,DE,HL:j
;
_fprnt::
	ld HL, (#ibfad)
	xor A
	cp (HL)
	ret Z

	inc HL
	jp _print_filename

;
; ^ꂽt@CFCB̃t@CƔr
;
; 
; DE:t@C̐擪AhX
;
; o
; Z:v NZ:sv
; A:j
;
_fsame::
	push BC
	push DE
	push HL
	
	call _fsame_main
	
	pop HL
	pop DE
	pop BC
	ret

_fsame_main:
	ld HL, #_fsame_buffer
	call _reg_file
	ret C
	ld DE, (#ibfad)
	inc DE
	
	ld B, #11
_fsame_loop:
	ld A, (DE)
	cp (HL)
	ret NZ
	inc DE
	inc HL
	djnz _fsame_loop
	ret

_fsame_buffer:
	.db 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

;
; t@Cǂݍ݃I[v
;
; 
; Ȃ
;
; o
; A:G[R[h
; Cy:G[ NC:
; BC,DE,HL:j
;
_ropen::
	call _check_ibuf
	ret C
	call _find_file
	jp C, _file_ng

	push IX
	ld IX, (#ibfad)
	ld D, IBUF_DTADR_OFFSET+1(IX)
	ld E, IBUF_DTADR_OFFSET+0(IX)
	ld (#dtadr), DE
	ld D, IBUF_SIZE_OFFSET+1(IX)
	ld E, IBUF_SIZE_OFFSET+0(IX)
	ld (#size), DE
	ld D, IBUF_EXADR_OFFSET+1(IX)
	ld E, IBUF_EXADR_OFFSET+0(IX)
	ld (#exadr), DE
	pop IX

	xor A
	ret

;
; t@Cǂݍ
;
; 
; Ȃ
;
; o
; A:G[R[h
; Cy:G[ NC:
; BC,DE,HL:j
;
_rdd::
	call _check_ibuf
	ret C
	
	push IX
	ld IX, (#ibfad)
	ld B, IBUF_SIZE_OFFSET+1(IX)
	ld C, IBUF_SIZE_OFFSET+0(IX)
	ld D, IBUF_BODY_OFFSET+1(IX)
	ld E, IBUF_BODY_OFFSET+0(IX)
	ex DE, HL
	pop IX
	ld DE, (#dtadr)
	ldir
	jp _del_ibuf

;
; t@C݃I[v
;
; 
; Ȃ
;
; o
; A:G[R[h
; Cy:G[ NC:
; BC,DE,HL:j
;
_wopen::
	call _check_ibuf
	ret C
	call _find_file

	xor A
	ret

;
; t@Cǂݍ
;
; 
; Ȃ
;
; o
; A:G[R[h
; Cy:G[ NC:
; BC,DE,HL:j
;
_wrd::
	call _check_ibuf
	ret C
	call _check_protect
	jp C, _file_ng
	call _find_file

	; t@C݌̎cfBXN𓾂
	push AF
	push BC
	call _get_diskspace
	ld DE, (#size)
	or A
	sbc HL, DE
	ld BC, #35 + 1
	or A
	sbc HL, BC
	pop BC
	pop AF

	; t@CTCY0x8000𒴂Ă邩?
	bit 7, D
	ld A, #ERROR_DEVICE_FULL
	jr NZ, _wrd_ng

	; C?
	ld IX, (#ibfad)
	jr C, _wrd_skip

	; t@CC̎cfBXN𓾂
	ld D, IBUF_REALSIZE_OFFSET+1(IX)
	ld E, IBUF_REALSIZE_OFFSET+0(IX)
	add HL, DE

	; cfBXNTCY`FbN
	call _wrd_check_space
	jp C, _file_ng

	; Ât@C폜
	push HL
	call _kill_main
	call _find_file
	pop HL

_wrd_skip:
	; cfBXNTCY`FbN
	call _wrd_check_space
	jp C, _file_ng

	push IX
	push IY

	; Et@CEpX[h
	ld HL, (#ibfad)
	ld D, IBUF_HEAD_OFFSET+1(IX)
	ld E, IBUF_HEAD_OFFSET+0(IX)
	push DE
	pop IY
	ld BC, #13
	ldir
	
	; t@CTCY
	inc DE
	inc DE
	inc DE
	inc DE
	ld HL, (#size)
	ld C, #35
	add HL, BC
	call _st

	; 擪AhX
	ld HL, (#dtadr)
	call _st
	
	; sJnAhX
	ld HL, (#exadr)
	call _st

	; f[^
	ld D, IBUF_BODY_OFFSET+1(IX)
	ld E, IBUF_BODY_OFFSET+0(IX)
	ld HL, (#dtadr)
	ld BC, (#size)
	pop IY
	pop IX
	; f[^TCY0̏ꍇ͏܂Ȃ
	ld A, B
	or C
	jr Z, _wrd_skip2
	ldir
_wrd_skip2:

	; I[
	ld A, #0xff
	ld (DE), A
	jp _del_ibuf

_wrd_ng:
	ld A, #ERROR_DEVICE_FULL
	scf
	jp _file_ng

_wrd_check_space:
	ld A, H
	rlca
	ld A, #ERROR_DEVICE_FULL
	ret

;
; t@CύX
;
; 
; Ȃ
;
; o
; A:G[R[h
; Cy:G[ NC:
; BC,DE,HL:j
;
_name::
	call _check_ibuf
	ret C
	call _check_protect
	jp C, _file_ng
	call _find_file
	jp C, _file_ng

	; Õt@C邩ׂ
	push BC
	push DE
	call _file
	call _find_file
	pop DE
	pop BC
	ccf
	ld A, #ERROR_FILE_ALREADY_EXISTS
	jp C, _file_ng

	; Vt@C𐳋K
	ld HL, #_buffer
	call _reg_file
	jp C, _file_ng

	; t@C̃AhX𓾂
	push IX
	ld DE, (#ibfad)
	call _get_fileinfo
	ld IX, (#ibfad)
	ld D, IBUF_HEAD_OFFSET+1(IX)
	ld E, IBUF_HEAD_OFFSET+0(IX)
	inc DE
	pop IX
	
	; 
	ld BC, #11
	ldir
	jp _del_ibuf

;
; t@C폜
;
; 
; Ȃ
;
; o
; A:G[R[h
; Cy:G[ NC:
; BC,DE,HL:j
;
_kill::
	call _check_ibuf
	ret C
	call _check_protect
	jp C, _file_ng
	call _find_file
	jp C, _file_ng
	
	call _kill_main
	jp _del_ibuf

_kill_main:
	push IX
	
	or A
	ld IX, (#ibfad)
	ld H, IBUF_REST_OFFSET+1(IX)
	ld L, IBUF_REST_OFFSET+0(IX)
	ld D, IBUF_REALSIZE_OFFSET+1(IX)
	ld E, IBUF_REALSIZE_OFFSET+0(IX)
	sbc HL, DE
	push HL

	ld H, IBUF_HEAD_OFFSET+1(IX)
	ld L, IBUF_HEAD_OFFSET+0(IX)
	push HL
	
	add HL, DE
	pop DE
	pop BC
	ldir

	pop IX
	ret

;
; o[W𓾂
;
; 
; Ȃ
;
; o
; H:@
; L:o[W
;
_ver::
	ld HL, #0xff20
	ret

;
; u[g
;
; 
; Ȃ
;
; o
; AF,BC,DE,HL:j
;
_boot::
.if DEBUG
	call _mprnt
	.ascii /BOOT\r\0/
.endif
	ld A, #0xff
	out (#0x11), A
	out (#0x12), A
	in A, (#0x10)
	or A
	jr NZ, _boot

	call init_screen
	call init_key
	ld SP, (#stkad)
	ret

;
; R[hX^[g
;
; 
; Ȃ
;
; o
; AF,BC,DE,HL:j
;
_cold::
.if DEBUG
	call _mprnt
	.ascii /COLD\r\0/
.endif
	ld HL, #0x7ff8
	ld (#stkad), HL
	ld HL, #0x2408
	ld (#maxlin), HL
	ld BC, #255
	ld DE, #_kbuf + 1
	ld HL, #_kbuf
	xor A
	ld (HL), A
	ldir
	ld HL, #_hot
	ld (#usr), HL
	jp (HL)

;
; zbgX^[g
;
; 
; Ȃ
;
; o
; AF,BC,DE,HL:j
;
_hot::
.if DEBUG
	call _mprnt
	.ascii /HOT\r\0/
.endif
	ld HL, (#0x7ffe)
	ld A, H
	or L
	jr NZ, _hot_skip
	ld HL, #0x7f00

_hot_skip:
	dec HL
	ld (#memax), HL
	call init_screen
	call init_key
	ld A, #FF
	call _print

;
; j^
;
; 
; Ȃ
;
; o
; AF,BC,DE,HL:j
;
_mon::
	call _mprnt
	.ascii /<<< S-OS 850 MONITOR >>>\r\0/
	ld A, #MON_ORIG
	ld (#_mon_mode), A

_mon_loop:
	ld A, (#_mon_mode)
	call _print
	ld DE, #_kbuf
	call _getl

	ld A, (#_mon_mode)
	cp #MON_ORIG
	inc DE
	ld A, (DE)
	inc DE
	jr Z, _mon_orig
_mon_ex:
	cp #"F"
	jp Z, _mon_format
	cp #"I"
	jp Z, _mon_info
	cp #"M"
	jp Z, _mon_sw_orig
_mon_orig:
	or A
	jr Z, _mon_loop
	cp #" "
	jr Z, _mon_loop
	cp #"!"
	jp Z, _boot
	cp #"D"
	jp Z, _mon_dir
	cp #"J"
	jp Z, _mon_jump
	cp #"K"
	jp Z, _mon_kill
	cp #"L"
	jp Z, _mon_load
	cp #"M"
	jp Z, _mon_sw_ex
	cp #"N"
	jp Z, _mon_name
	cp #"S"
	jp Z, _mon_save
_mon_syntax_error:
	ld A, #ERROR_SYNTAX_ERROR
_mon_error:
	call _error
	call _nl
	jr _mon_loop

_mon_mode:
	.db 0

_mon_dir:
	; DR}h: t@C\
	ld A, (#dvsw)
	ld (#dsk), A
	ld A, (DE)
	cp #"V"
	jr Z, _mon_dv
	or A
	jr Z, _mon_dir_skip
	ld (#dsk), A
_mon_dir_skip:
	call _dir
	jp C, _mon_error
	jp _mon_loop

_mon_dv:
	; DVR}h: JgfoCXύX
	inc DE
	ld A, (DE)
	ld (#dvsw), A
	jp _mon_loop

_mon_format:
	; FR}h: foCXtH[}bg
	call _mprnt
	.ascii /All files will be removed.\rHit Y key to format.\r\0/
	call _flget
	cp #"Y"
	jp NZ, _mon_loop
	ld A, #0xff
	ld (#ramdisk), A
	jp _mon_ok

_mon_info:
	; IR}h: \
	; ő僁𓾂
	ld HL, (#memax)
	ld DE, #_mon_info_memax
	call _asc4

	; fBXNXy[X𓾂
	ld HL, #sos - 1
	ld DE, #_mon_info_diskmax
	call _asc4

	; gpfBXN𓾂
	ld A, #"A"
	ld (#dsk), A
	call _get_diskspace
	ex DE, HL
	ld HL, #sos
	or A
	sbc HL, DE
	ld DE, #_mon_info_used
	call _asc4

	call _mprnt
_mon_info_text:
	.ascii /FREE:3000-/
_mon_info_memax:
	.ascii /____\rDISK:0100-/
_mon_info_diskmax:
	.ascii /____ (USED:0100-/
_mon_info_used:
	.ascii /____)\r\0/
	jp _mon_loop

_mon_jump:
	; JR}h: s
	call _hlhex
	jp C, _mon_syntax_error
	call _mon_jump0
	jp _mon_loop
_mon_jump0:
	jp (HL)

_mon_kill:
	; KR}h: t@C폜
	call _file
	jp C, _mon_error
	call _kill
	jp C, _mon_error
	jp _mon_ok

_mon_load:
	; LR}h: t@Cǂݍ
	; t@CI[v
	call _file
	jp C, _mon_error
	push DE
	call _ropen
	pop DE
	jp C, _mon_error

	; ݐ𓾂
	call _mon_sep
	jr NZ, _mon_load_skip
	call _hlhex
	jp C, _mon_syntax_error
	ld (#dtadr), HL

_mon_load_skip:
	; t@Cǂݍ
	call _rdd
	jp C, _mon_error
_mon_ok:
	call _mprnt
	.ascii /OK\r\0/
	jp _mon_loop

_mon_sw_ex:
	; MR}h: j^؂ւ
	ld A, #MON_EX
	ld (#_mon_mode), A
	jp _mon_loop
_mon_sw_orig:
	ld A, #MON_ORIG
	ld (#_mon_mode), A
	jp _mon_loop

_mon_name:
	; NR}h: t@CύX
	call _file
	jp C, _mon_error
	call _mon_sep
	jp NZ, _mon_error
	call _name
	jp C, _mon_error
	jp _mon_ok

_mon_save:
	; SR}h: t@C
	; t@Cݒ肷
	ld A, #ATTR_BIN
	call _file
	jr C, _mon_save_ng
	
	; ":"邩?
	call _mon_sep
	jr NZ, _mon_save_ng
	
	; JnAhXݒ肷
	call _hlhex
	jr C, _mon_save_ng
	ld (#dtadr), HL
	ld B, H
	ld C, L

	; ":"邩?
	call _mon_sep
	jr NZ, _mon_save_ng

	; TCY
	call _hlhex
	jr C, _mon_save_ng
	or A
	sbc HL, BC
	ld (#size), HL

	; sAhX
	ld H, B
	ld L, C
	call _mon_sep
	jr NZ, _mon_save_skip
	call _hlhex
	jr C, _mon_save_ng
_mon_save_skip:
	ld (#exadr), HL

	; t@C
	call _wopen
	jr C, _mon_save_ng
	call _wrd
	jr C, _mon_save_ng
	jp _mon_ok
_mon_save_ng:
	jp _mon_error

_mon_sep:
	; ":"邩ׂ
	ld A, (DE)
	cp #":"
	scf
	ld A, #ERROR_SYNTAX_ERROR
	ret NZ
	inc DE
	xor A
	ret

; FCBobt@
_ibuf::
	.db 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	.db 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

; ėpobt@
_buffer::
	.db 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	.db 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

; ̓obt@
_kbuf::
	.db 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	.db 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	.db 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	.db 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	.db 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	.db 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	.db 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	.db 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	.db 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	.db 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	.db 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	.db 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	.db 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	.db 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	.db 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	.db 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

; eof
